# Rotex.py	versione: 2011_10_14 Modificato By:Gasala50
# Collezione di Python class per semplificare l'uso di una scheda FOXG20

import serial
import thread
import threading
import time
import fox
from pysqlite2 import dbapi2 as sqlite
from time import gmtime, strftime

# Temperature sensor ID available on /sys/bus/w1/devices  
asensor = fox.DS18S20("000801ea499c")
bsensor = fox.DS18S20("000801d598d0")
csensor = fox.DS18S20("000801d5a5e0")
#	dsensor = fox.DS18S20("000801537dd0")
# definizione I/O
ledverde = fox.Pin('J7.3','low')	# uscita segnale di BK 
ledgiallo = fox.Pin('J7.4','low')	# uscita segnale di Pt1 attiv. Pompa Trasf. 1
button = fox.Pin('J7.5','in')	# ingresso segn. abilitazione On R1 e/o R2
ledrosso = fox.Pin('J7.6','low')	# uscita segnale di Pt2 attiv. Pompa Trasf. 2
led_R1 = fox.Pin('J7.31','low')	# uscita segnale di R1 attiv. Resistenza 1
led_R2 = fox.Pin('J7.32','low')	# uscita segnale di R2 attiv. Resistenza 2

Go=1

class ricevi(threading.Thread):
	def __init__ (self, ser):
		threading.Thread.__init__(self)
		self.ser=ser
	def run(self):
		Tsa = asensor.getTemp()
		Ts1 = bsensor.getTemp()
		Ts2 = csensor.getTemp()
		T = 0		# Variabile di couter tempo di ciclo di invio dati da RPS/3
		E = 0		# Val. di accumulatore Energia ogni 5 secondi
		TEg = 0	# Val. base per sommatore Energia Prodotta in un giorno
		TEtbase = 14741.0
		TEt = TEtbase	# Val. base per totalizzatore Energia Prodotta
		DTon = 5	# Differenziale di accensione pompa riciclo
		DToff = 3	# Differenziale di spegnimento pompa riciclo
		Pt1 = 0	# Valore x Pompa di Trasferimento 1 Ferma
		Pt2 = 0	# Valore x Pompa di Trasferimento 2 Ferma
		Sw = 0		# segnale Abilitazione R1 e/o R2 con tariffa ridotta 
		SRon = 45	# Soglia Limite di accensione Norm. R1 e/o R2
		SERon = 40	# Soglia di Emergenza di Accensione R1 e/o R2
		SRoff = 49.6	# Soglia di Spegnimento R1 e/o R2
		R1 = 0		# Segnale di Accensione R1
		R1c = 0	# Contatore KWh integrati da R1
		R2 = 0		# Segnale di Accensione R2
		R2c = 0	# Contatore KWh integrati da R2

		while Go:
			s=self.ser.read(50)
			if s:
				s=str.split(s,';',8)	# lettura dati proveniente da Rotex RPS/3 
				HA=int(s[0])
				BK=int(s[1])
				P1=int(s[2])
				P2=int(s[3])
				TK=int(s[4])
				TR=int(s[5])
				TS=int(s[6])
				TV=int(s[7])
				QT=s[8]
				P=float(QT.replace(',', '.'))
# Applicazione polinomiale lineare di correzione temperatura (solo su TR)
				TRc=int(round((TR-0.5)*0.938+1.448,0))
# Calcolo Potenza istantanea ogni 5 secondi
				if P > 0:
					W=(TV-TRc)*P*0.0697
				else:
					W = 0
# Calcolo Energia
				E5 = W*0.00139	#Ciclo di 5 secondi / 3600 secondi in un'ora
				E = E + E5		#Sommatoria Energia al minuto (5 sec x 12 cicli)

# Controllo del segnale di blocco integrazione con energia elettrica (rps/3)
				if BK == 1:
					ledverde.on()
				else:
					ledverde.off()
# Controllo del segnale [Button] di abilitazione Accensione Resistenze di Integrazione
				if button.getValue()==0:
					Sw = 1
				else:
					Sw = 0 
# Controllo tempo di ciclo ogni 5 secondi

				T = T + 1

				print HA ,BK ,P1 ,P2 ,TK ,TR ,TS ,TV ,'%.1f' %P ,'%.2f' %W ,'%.3f' %E, Sw
 
# Lettura valori di temperatura delle sonde 1-wire DS18S20 Tsa, Ts1, Ts2
				if T == 2:
					ta = Tsa
					Tsa = asensor.getTemp()
					if Tsa == "Wrong CRC":
						Tsa = float(ta)
				if T == 5:
					tb = Ts1
					Ts1 = bsensor.getTemp()
					if Ts1 == "Wrong CRC":
						Ts1 = float(tb)
				if T == 8:
					tc = Ts2
					Ts2 = csensor.getTemp()
					if Ts2 == "Wrong CRC":
						Ts2 = float(tc)
#				if T == 10:
#					td = Tes
#					Tes = dsensor.getTemp()
#					if Tes == "Worong CRC":
#						Tes = Float(td)
# ---------------- Cliclo di memorizzazione con tempo 60 secondi = 1 minuto primo -------------
				if T == 12:
					TEg = TEg + E			# Sommatoria Energia Giornaliera
					TEt = TEt + E 		# Contatore Energia Impianto 
# Controllo temperature per attivazione Pompa di riciclo sanicube n.1
					T1 = Tsa - Ts1
					if T1 >= DTon:
						ledgiallo.on()
						time.sleep(0.4)
						Pt1 = 1
					if T1 <= DToff:
						ledgiallo.off()
						Pt1 = 0
# Controllo temperature per attivazione Pompa di riciclo sanicube n.2
					T2 = Tsa - Ts2
					if T2 >= DTon:
						ledrosso.on()
						time.sleep(0.4)
						Pt2 = 1
					if T2 <= DToff:
						ledrosso.off()
						Pt2 = 0
# Controllo temp.Ts1 con SRon e SERon per attivazione R1 cond. o meno da BK And Ingr.Botton
					if not BK and Sw:
						if Ts1<=SRon:
							R1 = 1
							led_R1.on()
					if Ts1<=SERon:
						R1 = 1
						led_R1.on()
					if Ts1>=SRoff:
						R1 = 0
						led_R1.off()
					if R1 == 1:
						R1c = R1c + 0.034
# Controllo temp.Ts2 con SRon e SERon per attivazione R2 cond. o meno da BK And Ingr.Botton
					if not BK and Sw:
						if Ts2<=SRon:
							R2 = 1
							led_R2.on()
					if Ts2<=SERon:
						R2 = 1
						led_R2.on()
					if Ts2>=SRoff:
						R2 = 0
						led_R2.off()
					if R2 == 1:
						R2c = R2c + 0.034
# -------------------------------------------------------------------------------------------------
					print 'E.Day',"%.3f" %TEg,'Tot E Sol',"%.3f" %TEt,\
'Count R1',"%.2f" %R1c,'Count R2',"%.2f" %R2c,'Temp.',"%.1f" %Tsa,"%.1f" %Ts1,"%.1f" %Ts2	#,"%.1f" %Tes

# Insert a new record on tables 'tabrps_acs' on the SQLite database "rotex"

					connection = sqlite.connect('/var/www/rotex.sqlite')
					cursor = connection.cursor()

					cursor.execute('CREATE TABLE IF NOT EXISTS tabrps_acs \
(id INTEGER PRIMARY KEY AUTOINCREMENT, date TEXT, time TEXT, BK TEXT, P1 INTEGER, P2 INTEGER,\
 TK INTEGER, TR INTEGER, TS INTEGER, TV INTEGER, Tsa FLOAT , Ts1 FLOAT, Ts2 FLOAT, P FLOAT ,\
 W FLOAT, E FLOAT, TEg FLOAT, TEt FLOAT, Pt1 INTEGER, Pt2 INTEGER, R1 INTEGER, R1c FLOAT, R2 INTEGER, R2c FLOAT, Sw INTEGER)')

					cursor.execute('INSERT INTO tabrps_acs VALUES (null,\
 date("now","localtime"),time("now","localtime"),' + "%s" %BK + ',' + "%3d" %P1 + ',\
' + "%d" %P2 + ',' + "%3d" %TK + ',' + "%3d" %TR + ',' + "%2d" %TS + ',' + "%2d" %TV + ',\
' + "%.1f" % Tsa + ',' +"%.1f" % Ts1 + ',' +"%.1f" % Ts2 + ',' +"%.1f" %P + ',' + "%.1f" %W + ',\
' +"%.3f" %E + ',' +"%.3f" %TEg + ',' +"%.1f" %TEt + ',' + "%d" %Pt1 + ',' + "%d" %Pt2 + ',\
' + "%d" %R1 + ',' + "%.2f" %R1c + ',' + "%d" %R2 + ',' + "%.2f" %R2c + ',' + "%d" %Sw + ')')

					connection.commit()
					print "DB='rotex.sqlite'-'tabrps_acs' in Data:",time.strftime("%Y/%m/%d", time.localtime(time.time())),\
'ora:',time.strftime("%H:%M:%S", time.localtime(time.time()))
# ------------------------------------------------------------- Controllo fine giorno ------------------------------
					Scadenza = '23:59'							# Set Scadenza
					Timeout = time.strftime("%H:%M", time.localtime(time.time()))	# Read Tempo Corrente
					if Timeout == Scadenza:
						print Scadenza, '=', Timeout, 'Ok >> Tempo di Azzeramento Count a fine della giornata <<'
						TEtbase = TEt		# Salva valore di Count Energia Prodotta
						TEg = 0		# Azzeramento Count Tot.E giornaliera
						R1c = 0		# Azzeramento Count Tot. integrazione da R1
						R2c = 0		# Azzeramento Count Tot. integrazione da R2
					else:
						print 'Ora:', Timeout, 'Attendi le ore:', Scadenza, 'per Azzeramento valori dei Contatori'
# Fine Ciclo di un minuto -------------------------------------------------------------------------------------------
					E = 0
					T = 0

		print "fine",s

if __name__ == "__main__":
	ser=serial.Serial(port='/dev/ttyS1',timeout=0.1)
	ricevi(ser).start()
	while Go:
		send=raw_input()
		print "invio:",send,ser.write(send)
		ser.write(send)
		if not send:
			Go=0 
	time.sleep(1)
	ser.close()
